#!/usr/local/bin/ruby -w
#
# vim:sw=2 ts=8:et sta:fdm=marker
#
#
# Copyright (c) 2007 Ariff Abdullah <skywizard@MyBSD.org.my>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#        $MyBSD$
#
# Date: Mon May  7 15:16:24 MYT 2007
#   OS: FreeBSD yuki.MyBSD.org.my 6.2-STABLE i386
#

trap("SIGCHLD") do
  begin
    Process.waitpid(-1, Process::WNOHANG)
  rescue
  end
end

COOKIE = "/tmp/sNd-_clOn3-strEsSs-t35t-.c0ok13"

how = (ARGV[0] || "fork").downcase()
count = (ARGV[1] || 1).to_i()
dev = ARGV[2] || "/dev/dsp"

cycles = %w[fork mtime thread]

def torture(i, dev, mt)
    begin
      p [$$, i, :WAIT]
      while File.exist?(COOKIE) do
      end
#=begin
      xt = File.mtime(dev);
      p [i, mt ? File.mtime(dev) : fd = File.open(dev, 'w')]
      sleep 1
      fd.close()
      xt = File.mtime(dev);
#=end
      p [i, :EXIT]
    rescue
      p [$!, i]
    end
end

Thread.abort_on_exception = false
File.open(COOKIE, "w")
1.upto(count) do |i|
  chow = how == "cycle" ? cycles[i % 3] : how
  if chow == "fork" || chow == "mtime"
    fork do
      Process.setsid()
      torture(i, dev, chow == "mtime" ? true : false)
      exit!(0)
    end
  elsif chow == "thread"
    Thread.new do
      torture(i, dev, false)
    end
  else
    raise ArgumentError, "Invalid '#{chow}'"
  end
end

sleep 1
system("logger -t SND_PCM_#{how.upcase()} ################# OPEN ####################")
sleep 0.1
File.unlink(COOKIE)
sleep 0.25
system("fstat | grep '\\(dsp\\|dspW\\|audio\\)[0-9]'")
system("logger -t SND_PCM_#{how.upcase()} ################# CLOSE ###################")
sleep 3
